/*
Nome: 9805_CDPTRGS_LOG_CDP_RECURETAPA.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato

 Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              RECURETAPA, para verifio de erros */
IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_CDP_RECURETAPA' AND
                TYPE   = 'TR'                 AND
                U.UID  = O.UID                AND
                U.NAME = USER)

DROP TRIGGER LOG_CDP_RECURETAPA
GO


CREATE TRIGGER LOG_CDP_RECURETAPA
ON RECURETAPA
FOR UPDATE,INSERT, DELETE
AS
BEGIN

   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(2000);
   DECLARE @V_ITPESQ       VARCHAR(80);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDCLIEATIV   VARCHAR(1);
   DECLARE @V_NRINCREST    VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_TRIGGER         VARCHAR(1);

   DECLARE @V_CDFILIAL_OLD       VARCHAR(4);
   DECLARE @V_CDPRODUTO_OLD      VARCHAR(10);
   DECLARE @V_CDPROCFABRIC_OLD   VARCHAR(10);
   DECLARE @V_CDETAPAPROD_OLD    VARCHAR(10);
   DECLARE @V_CDINSPECAO_OLD     VARCHAR(10);
   DECLARE @V_NRINSPETAPA_OLD    VARCHAR(3);
   DECLARE @V_NRRECURETAPA_OLD   VARCHAR(3);
   DECLARE @V_CDEQUIPPRO_OLD     VARCHAR(10);
   DECLARE @V_CDHABILIDADE_OLD   VARCHAR(3);
   DECLARE @V_NRORDUTRECUR_OLD   VARCHAR(3);
   DECLARE @V_IDRECURETAPA_OLD   VARCHAR(1);
   DECLARE @V_QTPRODRECUR_OLD    double precision;
   DECLARE @V_QTHRUTRECUR_OLD    double precision;
   DECLARE @V_IDTEMPRECUR_OLD    VARCHAR(1);
   DECLARE @V_QTRECURETAPA_OLD   double precision;
   DECLARE @V_IDLIBERECU_OLD     VARCHAR(1);
   DECLARE @V_QTHRSETUPRECUR_OLD double precision;
   DECLARE @V_CDGRUPOEQUIPA_OLD  VARCHAR(10);

   DECLARE @V_CDFILIAL_NEW       VARCHAR(4);
   DECLARE @V_CDPRODUTO_NEW      VARCHAR(10);
   DECLARE @V_CDPROCFABRIC_NEW   VARCHAR(10);
   DECLARE @V_CDETAPAPROD_NEW    VARCHAR(10);
   DECLARE @V_CDINSPECAO_NEW     VARCHAR(10);
   DECLARE @V_NRINSPETAPA_NEW    VARCHAR(3);
   DECLARE @V_NRRECURETAPA_NEW   VARCHAR(3);
   DECLARE @V_CDEQUIPPRO_NEW     VARCHAR(10);
   DECLARE @V_CDHABILIDADE_NEW   VARCHAR(3);
   DECLARE @V_NRORDUTRECUR_NEW   VARCHAR(3);
   DECLARE @V_IDRECURETAPA_NEW   VARCHAR(1);
   DECLARE @V_QTPRODRECUR_NEW    double precision;
   DECLARE @V_QTHRUTRECUR_NEW    double precision;
   DECLARE @V_IDTEMPRECUR_NEW    VARCHAR(1);
   DECLARE @V_QTRECURETAPA_NEW   double precision;
   DECLARE @V_IDLIBERECU_NEW     VARCHAR(1);
   DECLARE @V_QTHRSETUPRECUR_NEW double precision;
   DECLARE @V_CDGRUPOEQUIPA_NEW  VARCHAR(10);

/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDCLIEATIV = '';
   SET @V_NRINCREST  = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         CDFILIAL,
         CDPRODUTO,
         CDPROCFABRIC,
         CDETAPAPROD,
         CDINSPECAO,
         NRINSPETAPA,
         NRRECURETAPA,
         CDEQUIPPRO,
         CDHABILIDADE,
         NRORDUTRECUR,
         IDRECURETAPA,
         QTPRODRECUR,
         QTHRUTRECUR,
         IDTEMPRECUR,
         QTRECURETAPA,
         IDLIBERECU,
         QTHRSETUPRECUR,
         CDGRUPOEQUIPA,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,
         DELETED.CDFILIAL,
         DELETED.CDPRODUTO,
         DELETED.CDPROCFABRIC,
         DELETED.CDETAPAPROD,
         DELETED.CDINSPECAO,
         DELETED.NRINSPETAPA,
         DELETED.NRRECURETAPA,
         DELETED.CDEQUIPPRO,
         DELETED.CDHABILIDADE,
         DELETED.NRORDUTRECUR,
         DELETED.IDRECURETAPA,
         DELETED.QTPRODRECUR,
         DELETED.QTHRUTRECUR,
         DELETED.IDTEMPRECUR,
         DELETED.QTRECURETAPA,
         DELETED.IDLIBERECU,
         DELETED.QTHRSETUPRECUR,
         DELETED.CDGRUPOEQUIPA,
         INSERTED.CDFILIAL,
         INSERTED.CDPRODUTO,
         INSERTED.CDPROCFABRIC,
         INSERTED.CDETAPAPROD,
         INSERTED.CDINSPECAO,
         INSERTED.NRINSPETAPA,
         INSERTED.NRRECURETAPA,
         INSERTED.CDEQUIPPRO,
         INSERTED.CDHABILIDADE,
         INSERTED.NRORDUTRECUR,
         INSERTED.IDRECURETAPA,
         INSERTED.QTPRODRECUR,
         INSERTED.QTHRUTRECUR,
         INSERTED.IDTEMPRECUR,
         INSERTED.QTRECURETAPA,
         INSERTED.IDLIBERECU,
         INSERTED.QTHRSETUPRECUR,
         INSERTED.CDGRUPOEQUIPA

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDPRODUTO  = DELETED.CDPRODUTO

      UNION ALL

      SELECT
        'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDFILIAL,
         CDPRODUTO,
         CDPROCFABRIC,
         CDETAPAPROD,
         CDINSPECAO,
         NRINSPETAPA,
         NRRECURETAPA,
         CDEQUIPPRO,
         CDHABILIDADE,
         NRORDUTRECUR,
         IDRECURETAPA,
         QTPRODRECUR,
         QTHRUTRECUR,
         IDTEMPRECUR,
         QTRECURETAPA,
         IDLIBERECU,
         QTHRSETUPRECUR,
         CDGRUPOEQUIPA

     FROM
        INSERTED
     WHERE
        0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

            			 @V_CDFILIAL_OLD,
             			 @V_CDPRODUTO_OLD,
             			 @V_CDPROCFABRIC_OLD,
             			 @V_CDETAPAPROD_OLD,
             			 @V_CDINSPECAO_OLD,
             			 @V_NRINSPETAPA_OLD,
             			 @V_NRRECURETAPA_OLD,
             			 @V_CDEQUIPPRO_OLD,
             			 @V_CDHABILIDADE_OLD,
             			 @V_NRORDUTRECUR_OLD,
             			 @V_IDRECURETAPA_OLD,
             			 @V_QTPRODRECUR_OLD,
             			 @V_QTHRUTRECUR_OLD,
             			 @V_IDTEMPRECUR_OLD,
             			 @V_QTRECURETAPA_OLD,
		                 @V_IDLIBERECU_OLD,
             			 @V_QTHRSETUPRECUR_OLD,
             			 @V_CDGRUPOEQUIPA_OLD,

		                 @V_CDFILIAL_NEW,
             			 @V_CDPRODUTO_NEW,
             			 @V_CDPROCFABRIC_NEW,
             			 @V_CDETAPAPROD_NEW,
             			 @V_CDINSPECAO_NEW,
             			 @V_NRINSPETAPA_NEW,
		                 @V_NRRECURETAPA_NEW,
             			 @V_CDEQUIPPRO_NEW,
             			 @V_CDHABILIDADE_NEW,
             			 @V_NRORDUTRECUR_NEW,
             			 @V_IDRECURETAPA_NEW,
             			 @V_QTPRODRECUR_NEW,
             			 @V_QTHRUTRECUR_NEW,
             			 @V_IDTEMPRECUR_NEW,
             			 @V_QTRECURETAPA_NEW,
             			 @V_IDLIBERECU_NEW,
             			 @V_QTHRSETUPRECUR_NEW,
             			 @V_CDGRUPOEQUIPA_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN

    IF @V_ID_TRIGGER = 'I' BEGIN

           IF @V_CDFILIAL_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'Filial= ' + ISNULL(@V_CDFILIAL_NEW,'') + ' ';
           END;

           IF @V_CDPRODUTO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_NEW,'') + ' ';
           END;

           IF @V_CDPROCFABRIC_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProcFabric= ' + ISNULL(@V_CDPROCFABRIC_NEW,'') + ' ';
           END;

           IF @V_CDETAPAPROD_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdEtapaProd= ' + ISNULL(@V_CDETAPAPROD_NEW,'') + ' ';
           END;

           IF @V_CDINSPECAO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdInspecao= ' + ISNULL(@V_CDINSPECAO_NEW,'') + ' ';
           END;

           IF @V_NRINSPETAPA_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NrInspeTapa= ' + ISNULL(@V_NRINSPETAPA_NEW,'') + ' ';
           END;

           IF @V_NRRECURETAPA_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NrRecurEtapa= ' + ISNULL(@V_NRRECURETAPA_NEW,'') + ' ';
           END;

           IF @V_CDEQUIPPRO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdEquipaProd= ' + @V_CDEQUIPPRO_NEW + ' ';
           END;

           IF @V_CDHABILIDADE_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdHabilidade= ' + @V_CDHABILIDADE_NEW + ' ';
           END;

           IF @V_NRORDUTRECUR_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NrOrdUtilRecurEtapa= ' + @V_NRORDUTRECUR_NEW + ' ';
           END;

           IF @V_IDRECURETAPA_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdRecurEtapa= ' + @V_IDRECURETAPA_NEW + ' ';
           END;

           IF @V_QTPRODRECUR_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtProdRecur= ' + RTRIM(CONVERT(CHAR, @V_QTPRODRECUR_NEW)) + ' ';
           END;

           IF @V_QTHRUTRECUR_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'HrPadraoUtilRecurEtapa= ' + RTRIM(CONVERT(CHAR, @V_QTHRUTRECUR_NEW)) + ' ';
           END;

           IF @V_IDTEMPRECUR_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdTempRecurEtapa= ' + @V_IDTEMPRECUR_NEW + ' ';
           END;

           IF @V_QTRECURETAPA_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtRecurEtapa= ' + RTRIM(CONVERT(CHAR, @V_QTRECURETAPA_NEW)) + ' ';
           END;

           IF @V_IDLIBERECU_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdLibeRecu= ' + @V_IDLIBERECU_NEW + ' ' ;
           END;

           IF @V_QTHRSETUPRECUR_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtHrSetupRecurso= ' + RTRIM(CONVERT(CHAR, @V_QTHRSETUPRECUR_NEW)) + ' ';
           END;

           IF @V_CDGRUPOEQUIPA_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdGrupoEquipamento= ' + @V_CDGRUPOEQUIPA_NEW + ' ';
           END;

           SET @V_ITPESQ = @V_CDFILIAL_NEW   + @V_CDPRODUTO_NEW   + @V_CDPROCFABRIC_NEW + @V_CDETAPAPROD_NEW +
                           @V_CDINSPECAO_NEW + @V_NRINSPETAPA_NEW + @V_NRRECURETAPA_NEW;

         SET @V_IDTIPOOPER = '1';
     END
     ELSE BEGIN
        IF @V_ID_TRIGGER = 'U' BEGIN

           IF (@V_CDFILIAL_OLD <> @V_CDFILIAL_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'Filial= ' + ISNULL(@V_CDFILIAL_NEW,'') + ' ';
           END;

           IF (@V_CDPRODUTO_OLD <> @V_CDPRODUTO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_NEW,'') + ' ';
           END;

           IF (@V_CDPROCFABRIC_OLD <> @V_CDPROCFABRIC_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdProcFabric= ' + ISNULL(@V_CDPROCFABRIC_NEW,'') + ' ';
           END;

           IF (@V_CDETAPAPROD_OLD <> @V_CDETAPAPROD_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdEtapaProd= ' + ISNULL(@V_CDETAPAPROD_NEW,'') + ' ';
           END;

           IF (@V_CDINSPECAO_OLD <> @V_CDINSPECAO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdInspecao= ' + ISNULL(@V_CDINSPECAO_NEW,'') + ' ';
           END;

           IF (@V_NRINSPETAPA_OLD <> @V_NRINSPETAPA_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'NrInspeTapa= ' + ISNULL(@V_NRINSPETAPA_NEW,'') + ' ';
           END;

           IF (@V_NRRECURETAPA_OLD <> @V_NRRECURETAPA_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'NrRecurEtapa= ' + ISNULL(@V_NRRECURETAPA_NEW,'') + ' ';
           END;

           IF (@V_CDEQUIPPRO_OLD <> @V_CDEQUIPPRO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdEquipaProd= ' + @V_CDEQUIPPRO_NEW + ' ';
           END;

           IF (@V_CDHABILIDADE_OLD <> @V_CDHABILIDADE_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdHabilidade= ' + @V_CDHABILIDADE_NEW + ' ';
           END;

           IF (@V_NRORDUTRECUR_OLD <> @V_NRORDUTRECUR_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'NrOrdUtilRecurEtapa= ' + @V_NRORDUTRECUR_NEW + ' ';
           END;

           IF (@V_IDRECURETAPA_OLD <> @V_IDRECURETAPA_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdRecurEtapa= ' + @V_IDRECURETAPA_NEW + ' ';
           END;

           IF (ISNULL(@V_QTPRODRECUR_OLD,'-1') <> ISNULL(@V_QTPRODRECUR_NEW,'-1')) BEGIN
              SET @V_DESC = @V_DESC + 'QtProdRecur= ' + RTRIM(CONVERT(CHAR, @V_QTPRODRECUR_NEW)) + ' ';
           END;

           IF (ISNULL(@V_QTHRUTRECUR_OLD,'-1') <> ISNULL(@V_QTHRUTRECUR_NEW,'-1')) BEGIN
              SET @V_DESC = @V_DESC + 'HrPadraoUtilRecurEtapa= ' + RTRIM(CONVERT(CHAR, @V_QTHRUTRECUR_NEW)) + ' ';
           END;

           IF (@V_IDTEMPRECUR_OLD <> @V_IDTEMPRECUR_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdTempRecurEtapa= ' + @V_IDTEMPRECUR_NEW + ' ';
           END;

           IF (@V_QTRECURETAPA_OLD <> @V_QTRECURETAPA_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'QtRecurEtapa= ' + RTRIM(CONVERT(CHAR, @V_QTRECURETAPA_NEW)) + ' ';
           END;

           IF (ISNULL(@V_IDLIBERECU_OLD,'-1') <> ISNULL(@V_IDLIBERECU_NEW,'-1')) BEGIN
              SET @V_DESC = @V_DESC + 'IdLibeRecu= ' + @V_IDLIBERECU_NEW + ' ' ;
           END;

           IF (@V_QTHRSETUPRECUR_OLD <> @V_QTHRSETUPRECUR_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'QtHrSetupRecurso= ' + RTRIM(CONVERT(CHAR, @V_QTHRSETUPRECUR_NEW)) + ' ';
           END;

           IF (@V_CDGRUPOEQUIPA_OLD <> @V_CDGRUPOEQUIPA_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdGrupoEquipamento= ' + @V_CDGRUPOEQUIPA_NEW + ' ';
           END;


           SET @V_ITPESQ = @V_CDFILIAL_NEW   + @V_CDPRODUTO_NEW   + @V_CDPROCFABRIC_NEW + @V_CDETAPAPROD_NEW +
                           @V_CDINSPECAO_NEW + @V_NRINSPETAPA_NEW + @V_NRRECURETAPA_NEW;

           SET @V_IDTIPOOPER = '2';

        END;

        IF @V_ID_TRIGGER = 'D'  BEGIN

           IF @V_CDFILIAL_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'Filial= ' + ISNULL(@V_CDFILIAL_OLD,'') + ' ';
           END;

           IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_OLD,'') + ' ';
           END;

           IF @V_CDPROCFABRIC_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProcFabric= ' + ISNULL(@V_CDPROCFABRIC_OLD,'') + ' ';
           END;

           IF @V_CDETAPAPROD_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdEtapaProd= ' + ISNULL(@V_CDETAPAPROD_OLD,'') + ' ';
           END;

           IF @V_CDINSPECAO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdInspecao= ' + ISNULL(@V_CDINSPECAO_OLD,'') + ' ';
           END;

           IF @V_NRINSPETAPA_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NrInspeTapa= ' + ISNULL(@V_NRINSPETAPA_OLD,'') + ' ';
           END;

           IF @V_NRRECURETAPA_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NrRecurEtapa= ' + ISNULL(@V_NRRECURETAPA_OLD,'') + ' ';
           END;

           IF @V_CDEQUIPPRO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdEquipaProd= ' + @V_CDEQUIPPRO_OLD + ' ';
           END;

           IF @V_CDHABILIDADE_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdHabilidade= ' + @V_CDHABILIDADE_OLD + ' ';
           END;

           IF @V_NRORDUTRECUR_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'NrOrdUtilRecurEtapa= ' + @V_NRORDUTRECUR_OLD + ' ';
           END;

           IF @V_IDRECURETAPA_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdRecurEtapa= ' + @V_IDRECURETAPA_OLD + ' ';
           END;

           IF @V_QTPRODRECUR_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtProdRecur= ' + RTRIM(CONVERT(CHAR, @V_QTPRODRECUR_OLD)) + ' ';
           END;

           IF @V_QTHRUTRECUR_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'HrPadraoUtilRecurEtapa= ' + RTRIM(CONVERT(CHAR, @V_QTHRUTRECUR_OLD)) + ' ';
           END;

           IF @V_IDTEMPRECUR_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdTempRecurEtapa= ' + @V_IDTEMPRECUR_OLD + ' ';
           END;

           IF @V_QTRECURETAPA_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtRecurEtapa= ' + RTRIM(CONVERT(CHAR, @V_QTRECURETAPA_OLD)) + ' ';
           END;

           IF @V_IDLIBERECU_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdLibeRecu= ' + @V_IDLIBERECU_OLD + ' ' ;
           END;

           IF @V_QTHRSETUPRECUR_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtHrSetupRecurso= ' + RTRIM(CONVERT(CHAR, @V_QTHRSETUPRECUR_OLD)) + ' ';
           END;

           IF @V_CDGRUPOEQUIPA_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdGrupoEquipamento= ' + @V_CDGRUPOEQUIPA_OLD + ' ';
           END;

           SET @V_ITPESQ = @V_CDFILIAL_OLD   + @V_CDPRODUTO_OLD   + @V_CDPROCFABRIC_OLD + @V_CDETAPAPROD_OLD +
                           @V_CDINSPECAO_OLD + @V_NRINSPETAPA_OLD + @V_NRRECURETAPA_OLD;

           SET @V_IDTIPOOPER = '3';
        END;
     END;

     IF NOT (@V_DESC IS NULL) BEGIN

        INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                               IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                               DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                               DSMETUSUOPER, CDORESPOPER)
                    VALUES   ('RECURETAPA', GETDATE() ,    ISNULL(@V_NMOPERADOR,' '),
                               @V_IDTIPOOPER,   @V_DESC, @V_ITPESQ,
                               @V_DSSERVERRDM, @V_DSREMOTEADDR,  @V_DSREMOTEHOST,
                               @V_DSSERVMETHOD,   @V_DSREMOTEOPER);
     END;

   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

            			 @V_CDFILIAL_OLD,
             			 @V_CDPRODUTO_OLD,
             			 @V_CDPROCFABRIC_OLD,
             			 @V_CDETAPAPROD_OLD,
             			 @V_CDINSPECAO_OLD,
             			 @V_NRINSPETAPA_OLD,
             			 @V_NRRECURETAPA_OLD,
             			 @V_CDEQUIPPRO_OLD,
             			 @V_CDHABILIDADE_OLD,
             			 @V_NRORDUTRECUR_OLD,
             			 @V_IDRECURETAPA_OLD,
             			 @V_QTPRODRECUR_OLD,
             			 @V_QTHRUTRECUR_OLD,
             			 @V_IDTEMPRECUR_OLD,
             			 @V_QTRECURETAPA_OLD,
		                 @V_IDLIBERECU_OLD,
             			 @V_QTHRSETUPRECUR_OLD,
             			 @V_CDGRUPOEQUIPA_OLD,

		                 @V_CDFILIAL_NEW,
             			 @V_CDPRODUTO_NEW,
             			 @V_CDPROCFABRIC_NEW,
             			 @V_CDETAPAPROD_NEW,
             			 @V_CDINSPECAO_NEW,
             			 @V_NRINSPETAPA_NEW,
		                 @V_NRRECURETAPA_NEW,
             			 @V_CDEQUIPPRO_NEW,
             			 @V_CDHABILIDADE_NEW,
             			 @V_NRORDUTRECUR_NEW,
             			 @V_IDRECURETAPA_NEW,
             			 @V_QTPRODRECUR_NEW,
             			 @V_QTHRUTRECUR_NEW,
             			 @V_IDTEMPRECUR_NEW,
             			 @V_QTRECURETAPA_NEW,
             			 @V_IDLIBERECU_NEW,
             			 @V_QTHRSETUPRECUR_NEW,
             			 @V_CDGRUPOEQUIPA_NEW;


   END;

   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CDP_RECURETAPA','5.07.000';
GO
